unit Sample6_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, _MnOglCanvas, ExtCtrls, _MNdevice, _MNComTypes, _MNOglTools,
  _MNOglExTools, StdCtrls;

type
  TfrmMain = class(TForm)
    MNOglControl1: TMNOglControl;
    StatusBar1: TStatusBar;
    Splitter1: TSplitter;
    Panel1: TPanel;
    MnOglCanvas1: TMnOglCanvas;
    MNOglScene1: TMNOglScene;
    MNOglBox1: TMNOglBox;
    MNOglLight1: TMNOglLight;
    MNOglNav1: TMNOglNav;
    Memo1: TMemo;
    MNOglScene2: TMNOglScene;
    MNOglSphere1: TMNOglSphere;
    MNOglSphere2: TMNOglSphere;
    MNOglSphere3: TMNOglSphere;
    MNOglSphere4: TMNOglSphere;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation
uses
  _MnMath, _MnXYZ;

{$R *.DFM}

procedure TfrmMain.FormKeyPress(Sender: TObject; var Key: Char);
VAR
  B:TBase;
  M1, M2:TMatrix;
  G:TGerade;
begin
  Mnoglcanvas1.changing:= true;
  B:= Mnoglcanvas1.Projectionbase;
  // navigation handling
  If UpperCase(Key) = 'S' then begin
    BaseToMatrix (B, M1);
    G := NewGerade (MNOglCanvas1.Auge, B.BaseY);
    Rotationtomatrix3d (G, 5*Pi/180, M2);
    M1 := MulMat (M1, M2);
    B := MatrixToBase (M1);
  end
  else If UpperCase(Key) = 'D' then begin
    BaseToMatrix (B, M1);
    G := NewGerade (MNOglCanvas1.Auge, B.BaseY);
    Rotationtomatrix3d (G, -5*Pi/180, M2);
    M1 := MulMat (M1, M2);
    B := MatrixToBase (M1);
  end;
  If UpperCase(Key) = 'E' then begin
    BaseToMatrix (B, M1);
    G := NewGerade (MNOglCanvas1.Auge, B.BaseX);
    Rotationtomatrix3d (G, 5*Pi/180, M2);
    M1 := MulMat (M1, M2);
    B := MatrixToBase (M1);
  end
  else If UpperCase(Key) = 'X' then begin
    BaseToMatrix (B, M1);
    G := NewGerade (MNOglCanvas1.Auge, B.BaseX);
    Rotationtomatrix3d (G, -5*Pi/180, M2);
    M1 := MulMat (M1, M2);
    B := MatrixToBase (M1);
  end
  else If Ord(Key) = 32 then begin
    BaseToMatrix (B, M1);
    G := NewGerade (B.BaseO, B.BaseY);
    If (GetKeyState (vk_Shift) and $8000) <> 0 then begin
      Translationtomatrix3d (B.BaseZ, M2);
    end
    else begin
      Translationtomatrix3d (Mul (B.BaseZ, -1), M2);
    end;
    M1 := MulMat (M1, M2);
    B := MatrixToBase (M1);
  end;
  Mnoglcanvas1.Projectionbase:=B;
  Mnoglcanvas1.changing:= False;
end;

end.
